/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Rotated_90
* Screen size : <1280,720>
*
*******************************************************************************/

#ifndef Monitor_H
#define Monitor_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_MonitorABPMinMaxDialog.h"
#include "_MonitorABPSettingsDialog.h"
#include "_MonitorActioinButton.h"
#include "_MonitorColorSet.h"
#include "_MonitorCurtain.h"
#include "_MonitorDataStorage.h"
#include "_MonitorDeviceClass.h"
#include "_MonitorDialog.h"
#include "_MonitorDualValueItem.h"
#include "_MonitorECGMinMaxDialog.h"
#include "_MonitorECGSettingsDialog.h"
#include "_MonitorEtCO2MinMaxDialog.h"
#include "_MonitorIconButton.h"
#include "_MonitorInfoDialog.h"
#include "_MonitorMonitor.h"
#include "_MonitorOscilloscope.h"
#include "_MonitorPanel.h"
#include "_MonitorPatientItem.h"
#include "_MonitorScale.h"
#include "_MonitorSpO2MinMaxDialog.h"
#include "_MonitorTempMinMaxDialog.h"
#include "_MonitorValueItem.h"
#include "_MonitorValueSliderComponent.h"

/* Font resource : 'Monitor::FontDigitsXXL' */
EW_DECLARE_FONT_RES( MonitorFontDigitsXXL )

/* Font resource : 'Monitor::FontDigitsXL' */
EW_DECLARE_FONT_RES( MonitorFontDigitsXL )

/* Font resource : 'Monitor::FontDigitsL' */
EW_DECLARE_FONT_RES( MonitorFontDigitsL )

/* Font resource : 'Monitor::FontTextM' */
EW_DECLARE_FONT_RES( MonitorFontTextM )

/* Font resource : 'Monitor::FontTextS' */
EW_DECLARE_FONT_RES( MonitorFontTextS )

/* Bitmap resource : 'Monitor::IconButtonShadow' */
EW_DECLARE_BITMAP_RES( MonitorIconButtonShadow )

/* Bitmap resource : 'Monitor::Minus' */
EW_DECLARE_BITMAP_RES( MonitorMinus )

/* Bitmap resource : 'Monitor::Plus' */
EW_DECLARE_BITMAP_RES( MonitorPlus )

/* Bitmap resource : 'Monitor::Icons' */
EW_DECLARE_BITMAP_RES( MonitorIcons )

/* Bitmap resource : 'Monitor::EmWiLogo' */
EW_DECLARE_BITMAP_RES( MonitorEmWiLogo )

/* Forward declaration of the class Effects::ScaleTransition */
#ifndef _EffectsScaleTransition_
  EW_DECLARE_CLASS( EffectsScaleTransition )
#define _EffectsScaleTransition_
#endif

/* Forward declaration of the class WidgetSet::HorizontalSliderConfig */
#ifndef _WidgetSetHorizontalSliderConfig_
  EW_DECLARE_CLASS( WidgetSetHorizontalSliderConfig )
#define _WidgetSetHorizontalSliderConfig_
#endif

/* Forward declaration of the class WidgetSet::ValueDisplayConfig */
#ifndef _WidgetSetValueDisplayConfig_
  EW_DECLARE_CLASS( WidgetSetValueDisplayConfig )
#define _WidgetSetValueDisplayConfig_
#endif

/* User defined constant: 'Monitor::BackgroundDay' */
extern const XColor MonitorBackgroundDay;

/* User defined constant: 'Monitor::BackgroundNight' */
extern const XColor MonitorBackgroundNight;

/* User defined constant: 'Monitor::PanelDay' */
extern const XColor MonitorPanelDay;

/* User defined constant: 'Monitor::PanelNight' */
extern const XColor MonitorPanelNight;

/* User defined constant: 'Monitor::GreenDay' */
extern const XColor MonitorGreenDay;

/* User defined constant: 'Monitor::GreenNight' */
extern const XColor MonitorGreenNight;

/* User defined constant: 'Monitor::RedDay' */
extern const XColor MonitorRedDay;

/* User defined constant: 'Monitor::RedNight' */
extern const XColor MonitorRedNight;

/* User defined constant: 'Monitor::BlueDay' */
extern const XColor MonitorBlueDay;

/* User defined constant: 'Monitor::BlueNight' */
extern const XColor MonitorBlueNight;

/* User defined constant: 'Monitor::YellowDay' */
extern const XColor MonitorYellowDay;

/* User defined constant: 'Monitor::YellowNight' */
extern const XColor MonitorYellowNight;

/* User defined constant: 'Monitor::TextDay' */
extern const XColor MonitorTextDay;

/* User defined constant: 'Monitor::TextNight' */
extern const XColor MonitorTextNight;

/* User defined constant: 'Monitor::DialogDay' */
extern const XColor MonitorDialogDay;

/* User defined constant: 'Monitor::DialogNight' */
extern const XColor MonitorDialogNight;

/* User defined constant: 'Monitor::CurtainDay' */
extern const XColor MonitorCurtainDay;

/* User defined constant: 'Monitor::CurtainNight' */
extern const XColor MonitorCurtainNight;

/* User defined auto object: 'Monitor::Device' */
EW_DECLARE_AUTOOBJECT( MonitorDevice, MonitorDeviceClass )

/* User defined auto object: 'Monitor::DialogShowHideTransition' */
EW_DECLARE_AUTOOBJECT( MonitorDialogShowHideTransition, EffectsScaleTransition )

/* User defined auto object: 'Monitor::Colors' */
EW_DECLARE_AUTOOBJECT( MonitorColors, MonitorColorSet )

/* User defined auto object: 'Monitor::HorizontalSliderConfig' */
EW_DECLARE_AUTOOBJECT( MonitorHorizontalSliderConfig, WidgetSetHorizontalSliderConfig )

/* User defined auto object: 'Monitor::ValueDisplayConfig' */
EW_DECLARE_AUTOOBJECT( MonitorValueDisplayConfig, WidgetSetValueDisplayConfig )

/* User defined constant: 'Monitor::Title' */
extern const XStringRes MonitorTitle;

/* User defined constant: 'Monitor::InfoText' */
extern const XStringRes MonitorInfoText;

#ifdef __cplusplus
  }
#endif

#endif /* Monitor_H */

/* Embedded Wizard */
