/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Rotated_90
* Screen size : <1280,720>
*
*******************************************************************************/

#ifndef _MonitorDeviceClass_H
#define _MonitorDeviceClass_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_CoreTimer.h"
#include "_MonitorDataStorage.h"
#include "_TemplatesDeviceClass.h"

/* Forward declaration of the class Monitor::DeviceClass */
#ifndef _MonitorDeviceClass_
  EW_DECLARE_CLASS( MonitorDeviceClass )
#define _MonitorDeviceClass_
#endif


/* Deklaration of class : 'Monitor::DeviceClass' */
EW_DEFINE_FIELDS( MonitorDeviceClass, TemplatesDeviceClass )
  EW_OBJECT  ( ADCSimulationTimer, CoreTimer )
  EW_OBJECT  ( StorageECG_I,    MonitorDataStorage )
  EW_OBJECT  ( StorageECG_II,   MonitorDataStorage )
  EW_OBJECT  ( StorageECG_III,  MonitorDataStorage )
  EW_OBJECT  ( StorageABP,      MonitorDataStorage )
  EW_OBJECT  ( ValueSimulationTimer, CoreTimer )
  EW_VARIABLE( lastTime,        XUInt32 )
  EW_VARIABLE( lastPosEcg,      XFloat )
  EW_PROPERTY( SamplesPerSec,   XInt32 )
  EW_ARRAY   ( ecg_I,           XFloat, [40])
  EW_ARRAY   ( ecg_II,          XFloat, [40])
  EW_ARRAY   ( ecg_III,         XFloat, [40])
  EW_ARRAY   ( abp,             XFloat, [40])
  EW_PROPERTY( HeartRate,       XInt32 )
  EW_PROPERTY( ABPSys,          XInt32 )
  EW_PROPERTY( ABPDia,          XInt32 )
  EW_PROPERTY( SpO2,            XInt32 )
  EW_PROPERTY( EtCO2,           XInt32 )
  EW_PROPERTY( Temperature,     XInt32 )
  EW_PROPERTY( HeartRateMin,    XInt32 )
  EW_PROPERTY( HeartRateMax,    XInt32 )
  EW_PROPERTY( ABPSysMin,       XInt32 )
  EW_PROPERTY( ABPSysMax,       XInt32 )
  EW_PROPERTY( ABPDiaMin,       XInt32 )
  EW_PROPERTY( ABPDiaMax,       XInt32 )
  EW_PROPERTY( SpO2Min,         XInt32 )
  EW_PROPERTY( SpO2Max,         XInt32 )
  EW_PROPERTY( EtCO2Min,        XInt32 )
  EW_PROPERTY( EtCO2Max,        XInt32 )
  EW_PROPERTY( TemperatureMin,  XInt32 )
  EW_PROPERTY( TemperatureMax,  XInt32 )
  EW_PROPERTY( Speed,           XInt32 )
  EW_PROPERTY( ECGGain,         XInt32 )
  EW_PROPERTY( ABPGain,         XInt32 )
  EW_PROPERTY( ECGIntensity,    XInt32 )
  EW_PROPERTY( ABPIntensity,    XInt32 )
EW_END_OF_FIELDS( MonitorDeviceClass )

/* Virtual Method Table (VMT) for the class : 'Monitor::DeviceClass' */
EW_DEFINE_METHODS( MonitorDeviceClass, TemplatesDeviceClass )
EW_END_OF_METHODS( MonitorDeviceClass )

/* The method Init() is invoked automatically after the component has been created. 
   This method can be overridden and filled with logic containing additional initialization 
   statements. */
void MonitorDeviceClass_Init( MonitorDeviceClass _this, XHandle aArg );

/* This method is intended to be called by the device to notify the GUI application 
   about an alternation of its setting or state value. */
void MonitorDeviceClass_UpdateStorageECG_I( MonitorDeviceClass _this, XInt32 aNewValue );

/* Wrapper function for the non virtual method : 'Monitor::DeviceClass.UpdateStorageECG_I()' */
void MonitorDeviceClass__UpdateStorageECG_I( void* _this, XInt32 aNewValue );

/* The following define announces the presence of the method Monitor::DeviceClass.UpdateStorageECG_I(). */
#define _MonitorDeviceClass__UpdateStorageECG_I_

/* 'C' function for method : 'Monitor::DeviceClass.ADCSimulation()' */
void MonitorDeviceClass_ADCSimulation( MonitorDeviceClass _this, XObject sender );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetSamplesPerSec()' */
void MonitorDeviceClass_OnSetSamplesPerSec( MonitorDeviceClass _this, XInt32 value );

/* This method is intended to be called by the device to notify the GUI application 
   about an alternation of its setting or state value. */
void MonitorDeviceClass_UpdateStorageECG_II( MonitorDeviceClass _this, XInt32 aNewValue );

/* Wrapper function for the non virtual method : 'Monitor::DeviceClass.UpdateStorageECG_II()' */
void MonitorDeviceClass__UpdateStorageECG_II( void* _this, XInt32 aNewValue );

/* The following define announces the presence of the method Monitor::DeviceClass.UpdateStorageECG_II(). */
#define _MonitorDeviceClass__UpdateStorageECG_II_

/* This method is intended to be called by the device to notify the GUI application 
   about an alternation of its setting or state value. */
void MonitorDeviceClass_UpdateStorageECG_III( MonitorDeviceClass _this, XInt32 aNewValue );

/* Wrapper function for the non virtual method : 'Monitor::DeviceClass.UpdateStorageECG_III()' */
void MonitorDeviceClass__UpdateStorageECG_III( void* _this, XInt32 aNewValue );

/* The following define announces the presence of the method Monitor::DeviceClass.UpdateStorageECG_III(). */
#define _MonitorDeviceClass__UpdateStorageECG_III_

/* This method is intended to be called by the device to notify the GUI application 
   about an alternation of its setting or state value. */
void MonitorDeviceClass_UpdateStorageABP( MonitorDeviceClass _this, XInt32 aNewValue );

/* Wrapper function for the non virtual method : 'Monitor::DeviceClass.UpdateStorageABP()' */
void MonitorDeviceClass__UpdateStorageABP( void* _this, XInt32 aNewValue );

/* The following define announces the presence of the method Monitor::DeviceClass.UpdateStorageABP(). */
#define _MonitorDeviceClass__UpdateStorageABP_

/* This method is intended to be called by the device to notify the GUI application 
   about an alternation of its setting or state value. */
void MonitorDeviceClass_UpdateHeartRate( MonitorDeviceClass _this, XInt32 aNewValue );

/* Wrapper function for the non virtual method : 'Monitor::DeviceClass.UpdateHeartRate()' */
void MonitorDeviceClass__UpdateHeartRate( void* _this, XInt32 aNewValue );

/* The following define announces the presence of the method Monitor::DeviceClass.UpdateHeartRate(). */
#define _MonitorDeviceClass__UpdateHeartRate_

/* This method is intended to be called by the device to notify the GUI application 
   about an alternation of its setting or state value. */
void MonitorDeviceClass_UpdateABPSys( MonitorDeviceClass _this, XInt32 aNewValue );

/* Wrapper function for the non virtual method : 'Monitor::DeviceClass.UpdateABPSys()' */
void MonitorDeviceClass__UpdateABPSys( void* _this, XInt32 aNewValue );

/* The following define announces the presence of the method Monitor::DeviceClass.UpdateABPSys(). */
#define _MonitorDeviceClass__UpdateABPSys_

/* This method is intended to be called by the device to notify the GUI application 
   about an alternation of its setting or state value. */
void MonitorDeviceClass_UpdateABPDia( MonitorDeviceClass _this, XInt32 aNewValue );

/* Wrapper function for the non virtual method : 'Monitor::DeviceClass.UpdateABPDia()' */
void MonitorDeviceClass__UpdateABPDia( void* _this, XInt32 aNewValue );

/* The following define announces the presence of the method Monitor::DeviceClass.UpdateABPDia(). */
#define _MonitorDeviceClass__UpdateABPDia_

/* This method is intended to be called by the device to notify the GUI application 
   about an alternation of its setting or state value. */
void MonitorDeviceClass_UpdateSpO2( MonitorDeviceClass _this, XInt32 aNewValue );

/* Wrapper function for the non virtual method : 'Monitor::DeviceClass.UpdateSpO2()' */
void MonitorDeviceClass__UpdateSpO2( void* _this, XInt32 aNewValue );

/* The following define announces the presence of the method Monitor::DeviceClass.UpdateSpO2(). */
#define _MonitorDeviceClass__UpdateSpO2_

/* This method is intended to be called by the device to notify the GUI application 
   about an alternation of its setting or state value. */
void MonitorDeviceClass_UpdateEtCO2( MonitorDeviceClass _this, XInt32 aNewValue );

/* Wrapper function for the non virtual method : 'Monitor::DeviceClass.UpdateEtCO2()' */
void MonitorDeviceClass__UpdateEtCO2( void* _this, XInt32 aNewValue );

/* The following define announces the presence of the method Monitor::DeviceClass.UpdateEtCO2(). */
#define _MonitorDeviceClass__UpdateEtCO2_

/* This method is intended to be called by the device to notify the GUI application 
   about an alternation of its setting or state value. */
void MonitorDeviceClass_UpdateTemperature( MonitorDeviceClass _this, XInt32 aNewValue );

/* Wrapper function for the non virtual method : 'Monitor::DeviceClass.UpdateTemperature()' */
void MonitorDeviceClass__UpdateTemperature( void* _this, XInt32 aNewValue );

/* The following define announces the presence of the method Monitor::DeviceClass.UpdateTemperature(). */
#define _MonitorDeviceClass__UpdateTemperature_

/* 'C' function for method : 'Monitor::DeviceClass.OnSetHeartRateMin()' */
void MonitorDeviceClass_OnSetHeartRateMin( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetHeartRateMax()' */
void MonitorDeviceClass_OnSetHeartRateMax( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetABPSysMin()' */
void MonitorDeviceClass_OnSetABPSysMin( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetABPSysMax()' */
void MonitorDeviceClass_OnSetABPSysMax( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetABPDiaMin()' */
void MonitorDeviceClass_OnSetABPDiaMin( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetABPDiaMax()' */
void MonitorDeviceClass_OnSetABPDiaMax( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetSpO2Min()' */
void MonitorDeviceClass_OnSetSpO2Min( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetSpO2Max()' */
void MonitorDeviceClass_OnSetSpO2Max( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetEtCO2Min()' */
void MonitorDeviceClass_OnSetEtCO2Min( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetEtCO2Max()' */
void MonitorDeviceClass_OnSetEtCO2Max( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetTemperatureMin()' */
void MonitorDeviceClass_OnSetTemperatureMin( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetTemperatureMax()' */
void MonitorDeviceClass_OnSetTemperatureMax( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetSpeed()' */
void MonitorDeviceClass_OnSetSpeed( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetECGGain()' */
void MonitorDeviceClass_OnSetECGGain( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetABPGain()' */
void MonitorDeviceClass_OnSetABPGain( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.ValueSimulation()' */
void MonitorDeviceClass_ValueSimulation( MonitorDeviceClass _this, XObject sender );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetECGIntensity()' */
void MonitorDeviceClass_OnSetECGIntensity( MonitorDeviceClass _this, XInt32 value );

/* 'C' function for method : 'Monitor::DeviceClass.OnSetABPIntensity()' */
void MonitorDeviceClass_OnSetABPIntensity( MonitorDeviceClass _this, XInt32 value );

/* Default onget method for the property 'SamplesPerSec' */
XInt32 MonitorDeviceClass_OnGetSamplesPerSec( MonitorDeviceClass _this );

/* Default onget method for the property 'HeartRate' */
XInt32 MonitorDeviceClass_OnGetHeartRate( MonitorDeviceClass _this );

/* Default onset method for the property 'HeartRate' */
void MonitorDeviceClass_OnSetHeartRate( MonitorDeviceClass _this, XInt32 value );

/* Default onget method for the property 'ABPSys' */
XInt32 MonitorDeviceClass_OnGetABPSys( MonitorDeviceClass _this );

/* Default onset method for the property 'ABPSys' */
void MonitorDeviceClass_OnSetABPSys( MonitorDeviceClass _this, XInt32 value );

/* Default onget method for the property 'ABPDia' */
XInt32 MonitorDeviceClass_OnGetABPDia( MonitorDeviceClass _this );

/* Default onset method for the property 'ABPDia' */
void MonitorDeviceClass_OnSetABPDia( MonitorDeviceClass _this, XInt32 value );

/* Default onget method for the property 'SpO2' */
XInt32 MonitorDeviceClass_OnGetSpO2( MonitorDeviceClass _this );

/* Default onset method for the property 'SpO2' */
void MonitorDeviceClass_OnSetSpO2( MonitorDeviceClass _this, XInt32 value );

/* Default onget method for the property 'EtCO2' */
XInt32 MonitorDeviceClass_OnGetEtCO2( MonitorDeviceClass _this );

/* Default onset method for the property 'EtCO2' */
void MonitorDeviceClass_OnSetEtCO2( MonitorDeviceClass _this, XInt32 value );

/* Default onget method for the property 'Temperature' */
XInt32 MonitorDeviceClass_OnGetTemperature( MonitorDeviceClass _this );

/* Default onset method for the property 'Temperature' */
void MonitorDeviceClass_OnSetTemperature( MonitorDeviceClass _this, XInt32 value );

/* Default onget method for the property 'HeartRateMin' */
XInt32 MonitorDeviceClass_OnGetHeartRateMin( MonitorDeviceClass _this );

/* Default onget method for the property 'HeartRateMax' */
XInt32 MonitorDeviceClass_OnGetHeartRateMax( MonitorDeviceClass _this );

/* Default onget method for the property 'ABPSysMin' */
XInt32 MonitorDeviceClass_OnGetABPSysMin( MonitorDeviceClass _this );

/* Default onget method for the property 'ABPSysMax' */
XInt32 MonitorDeviceClass_OnGetABPSysMax( MonitorDeviceClass _this );

/* Default onget method for the property 'ABPDiaMin' */
XInt32 MonitorDeviceClass_OnGetABPDiaMin( MonitorDeviceClass _this );

/* Default onget method for the property 'ABPDiaMax' */
XInt32 MonitorDeviceClass_OnGetABPDiaMax( MonitorDeviceClass _this );

/* Default onget method for the property 'SpO2Min' */
XInt32 MonitorDeviceClass_OnGetSpO2Min( MonitorDeviceClass _this );

/* Default onget method for the property 'SpO2Max' */
XInt32 MonitorDeviceClass_OnGetSpO2Max( MonitorDeviceClass _this );

/* Default onget method for the property 'EtCO2Min' */
XInt32 MonitorDeviceClass_OnGetEtCO2Min( MonitorDeviceClass _this );

/* Default onget method for the property 'EtCO2Max' */
XInt32 MonitorDeviceClass_OnGetEtCO2Max( MonitorDeviceClass _this );

/* Default onget method for the property 'TemperatureMin' */
XInt32 MonitorDeviceClass_OnGetTemperatureMin( MonitorDeviceClass _this );

/* Default onget method for the property 'TemperatureMax' */
XInt32 MonitorDeviceClass_OnGetTemperatureMax( MonitorDeviceClass _this );

/* Default onget method for the property 'Speed' */
XInt32 MonitorDeviceClass_OnGetSpeed( MonitorDeviceClass _this );

/* Default onget method for the property 'ECGGain' */
XInt32 MonitorDeviceClass_OnGetECGGain( MonitorDeviceClass _this );

/* Default onget method for the property 'ABPGain' */
XInt32 MonitorDeviceClass_OnGetABPGain( MonitorDeviceClass _this );

/* Default onget method for the property 'ECGIntensity' */
XInt32 MonitorDeviceClass_OnGetECGIntensity( MonitorDeviceClass _this );

/* Default onget method for the property 'ABPIntensity' */
XInt32 MonitorDeviceClass_OnGetABPIntensity( MonitorDeviceClass _this );

#ifdef __cplusplus
  }
#endif

#endif /* _MonitorDeviceClass_H */

/* Embedded Wizard */
