/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Rotated_90
* Screen size : <1280,720>
*
*******************************************************************************/

#ifndef _MonitorMonitor_H
#define _MonitorMonitor_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_CoreGroup.h"
#include "_CorePropertyObserver.h"
#include "_CoreSimpleTouchHandler.h"
#include "_CoreTimer.h"
#include "_EffectsInt32Effect.h"
#include "_MonitorActioinButton.h"
#include "_MonitorDualValueItem.h"
#include "_MonitorOscilloscope.h"
#include "_MonitorPanel.h"
#include "_MonitorPatientItem.h"
#include "_MonitorScale.h"
#include "_MonitorValueItem.h"
#include "_ViewsRectangle.h"
#include "_ViewsText.h"

/* Forward declaration of the class Core::DialogContext */
#ifndef _CoreDialogContext_
  EW_DECLARE_CLASS( CoreDialogContext )
#define _CoreDialogContext_
#endif

/* Forward declaration of the class Core::KeyPressHandler */
#ifndef _CoreKeyPressHandler_
  EW_DECLARE_CLASS( CoreKeyPressHandler )
#define _CoreKeyPressHandler_
#endif

/* Forward declaration of the class Core::LayoutContext */
#ifndef _CoreLayoutContext_
  EW_DECLARE_CLASS( CoreLayoutContext )
#define _CoreLayoutContext_
#endif

/* Forward declaration of the class Core::TaskQueue */
#ifndef _CoreTaskQueue_
  EW_DECLARE_CLASS( CoreTaskQueue )
#define _CoreTaskQueue_
#endif

/* Forward declaration of the class Core::View */
#ifndef _CoreView_
  EW_DECLARE_CLASS( CoreView )
#define _CoreView_
#endif

/* Forward declaration of the class Effects::Fader */
#ifndef _EffectsFader_
  EW_DECLARE_CLASS( EffectsFader )
#define _EffectsFader_
#endif

/* Forward declaration of the class Graphics::Canvas */
#ifndef _GraphicsCanvas_
  EW_DECLARE_CLASS( GraphicsCanvas )
#define _GraphicsCanvas_
#endif

/* Forward declaration of the class Monitor::ColorSet */
#ifndef _MonitorColorSet_
  EW_DECLARE_CLASS( MonitorColorSet )
#define _MonitorColorSet_
#endif

/* Forward declaration of the class Monitor::Curtain */
#ifndef _MonitorCurtain_
  EW_DECLARE_CLASS( MonitorCurtain )
#define _MonitorCurtain_
#endif

/* Forward declaration of the class Monitor::Dialog */
#ifndef _MonitorDialog_
  EW_DECLARE_CLASS( MonitorDialog )
#define _MonitorDialog_
#endif

/* Forward declaration of the class Monitor::Monitor */
#ifndef _MonitorMonitor_
  EW_DECLARE_CLASS( MonitorMonitor )
#define _MonitorMonitor_
#endif


/* Deklaration of class : 'Monitor::Monitor' */
EW_DEFINE_FIELDS( MonitorMonitor, CoreGroup )
  EW_OBJECT  ( Background,      ViewsRectangle )
  EW_OBJECT  ( BgColorObserver, CorePropertyObserver )
  EW_OBJECT  ( Panel,           MonitorPanel )
  EW_OBJECT  ( OscilloscopeECG_I, MonitorOscilloscope )
  EW_OBJECT  ( OscilloscopeECG_II, MonitorOscilloscope )
  EW_OBJECT  ( OscilloscopeECG_III, MonitorOscilloscope )
  EW_OBJECT  ( Panel1,          MonitorPanel )
  EW_OBJECT  ( OscilloscopeABP, MonitorOscilloscope )
  EW_OBJECT  ( PanelColorObserver, CorePropertyObserver )
  EW_OBJECT  ( RedColorObserver, CorePropertyObserver )
  EW_OBJECT  ( GreenColorObserver, CorePropertyObserver )
  EW_OBJECT  ( BlueColorObserver, CorePropertyObserver )
  EW_OBJECT  ( YellowColorObserver, CorePropertyObserver )
  EW_OBJECT  ( Panel2,          MonitorPanel )
  EW_OBJECT  ( Panel3,          MonitorPanel )
  EW_OBJECT  ( ScaleECG,        MonitorScale )
  EW_OBJECT  ( TextColorObserver, CorePropertyObserver )
  EW_OBJECT  ( ScaleABP,        MonitorScale )
  EW_OBJECT  ( HeartRateDisplay, MonitorValueItem )
  EW_OBJECT  ( SpO2Display,     MonitorValueItem )
  EW_OBJECT  ( EtCO2Display,    MonitorValueItem )
  EW_OBJECT  ( TemperatureDisplay, MonitorValueItem )
  EW_OBJECT  ( ABPDisplay,      MonitorDualValueItem )
  EW_OBJECT  ( DayNightButton,  MonitorActioinButton )
  EW_OBJECT  ( PrintButton,     MonitorActioinButton )
  EW_OBJECT  ( ArmButton,       MonitorActioinButton )
  EW_OBJECT  ( HeartButton,     MonitorActioinButton )
  EW_OBJECT  ( FingerButton,    MonitorActioinButton )
  EW_OBJECT  ( LungButton,      MonitorActioinButton )
  EW_OBJECT  ( FreezeButton,    MonitorActioinButton )
  EW_OBJECT  ( AlarmButton,     MonitorActioinButton )
  EW_OBJECT  ( CaptionText,     ViewsText )
  EW_OBJECT  ( PatientItem,     MonitorPatientItem )
  EW_OBJECT  ( SpeedObserver,   CorePropertyObserver )
  EW_OBJECT  ( ECGGainObserver, CorePropertyObserver )
  EW_OBJECT  ( ABPGainObserver, CorePropertyObserver )
  EW_OBJECT  ( CaptionTimer,    CoreTimer )
  EW_OBJECT  ( ECGTouchHandler, CoreSimpleTouchHandler )
  EW_OBJECT  ( ABPTouchHandler, CoreSimpleTouchHandler )
  EW_OBJECT  ( ECGIntensityObserver, CorePropertyObserver )
  EW_OBJECT  ( ABPIntensityObserver, CorePropertyObserver )
  EW_OBJECT  ( AutoDemoTimer,   CoreTimer )
  EW_OBJECT  ( DemoEffect,      EffectsInt32Effect )
  EW_VARIABLE( colors,          MonitorColorSet )
  EW_VARIABLE( dialog,          MonitorDialog )
  EW_VARIABLE( curtain,         MonitorCurtain )
  EW_VARIABLE( AutoState,       XInt32 )
EW_END_OF_FIELDS( MonitorMonitor )

/* Virtual Method Table (VMT) for the class : 'Monitor::Monitor' */
EW_DEFINE_METHODS( MonitorMonitor, CoreGroup )
  EW_METHOD( initLayoutContext, void )( CoreRectView _this, XRect aBounds, CoreOutline 
    aOutline )
  EW_METHOD( GetRoot,           CoreRoot )( CoreView _this )
  EW_METHOD( Draw,              void )( CoreGroup _this, GraphicsCanvas aCanvas, 
    XRect aClip, XPoint aOffset, XInt32 aOpacity, XBool aBlend )
  EW_METHOD( GetClipping,       XRect )( CoreGroup _this )
  EW_METHOD( HandleEvent,       XObject )( CoreView _this, CoreEvent aEvent )
  EW_METHOD( CursorHitTest,     CoreCursorHit )( CoreGroup _this, XRect aArea, XInt32 
    aFinger, XInt32 aStrikeCount, CoreView aDedicatedView, CoreView aStartView, 
    XSet aRetargetReason )
  EW_METHOD( AdjustDrawingArea, XRect )( CoreGroup _this, XRect aArea )
  EW_METHOD( ArrangeView,       XPoint )( CoreRectView _this, XRect aBounds, XEnum 
    aFormation )
  EW_METHOD( MoveView,          void )( CoreRectView _this, XPoint aOffset, XBool 
    aFastMove )
  EW_METHOD( GetExtent,         XRect )( CoreRectView _this )
  EW_METHOD( ChangeViewState,   void )( CoreGroup _this, XSet aSetState, XSet aClearState )
  EW_METHOD( OnSetBounds,       void )( CoreGroup _this, XRect value )
  EW_METHOD( OnSetFocus,        void )( CoreGroup _this, CoreView value )
  EW_METHOD( OnSetBuffered,     void )( CoreGroup _this, XBool value )
  EW_METHOD( OnSetOpacity,      void )( CoreGroup _this, XInt32 value )
  EW_METHOD( DispatchEvent,     XObject )( CoreGroup _this, CoreEvent aEvent )
  EW_METHOD( BroadcastEvent,    XObject )( CoreGroup _this, CoreEvent aEvent, XSet 
    aFilter )
  EW_METHOD( UpdateLayout,      void )( CoreGroup _this, XPoint aSize )
  EW_METHOD( UpdateViewState,   void )( CoreGroup _this, XSet aState )
  EW_METHOD( InvalidateArea,    void )( CoreGroup _this, XRect aArea )
EW_END_OF_METHODS( MonitorMonitor )

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorMonitor_onBgColorChanged( MonitorMonitor _this, XObject sender );

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorMonitor_onPanelColorChanged( MonitorMonitor _this, XObject sender );

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorMonitor_onRedColorChanged( MonitorMonitor _this, XObject sender );

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorMonitor_onGreenColorChanged( MonitorMonitor _this, XObject sender );

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorMonitor_onBlueColorChanged( MonitorMonitor _this, XObject sender );

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorMonitor_onYellowColorChanged( MonitorMonitor _this, XObject sender );

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorMonitor_onTextColorChanged( MonitorMonitor _this, XObject sender );

/* 'C' function for method : 'Monitor::Monitor.onDayNight()' */
void MonitorMonitor_onDayNight( MonitorMonitor _this, XObject sender );

/* 'C' function for method : 'Monitor::Monitor.onOpenECGMinMax()' */
void MonitorMonitor_onOpenECGMinMax( MonitorMonitor _this, XObject sender );

/* 'C' function for method : 'Monitor::Monitor.closeDialog()' */
void MonitorMonitor_closeDialog( MonitorMonitor _this, XObject sender );

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorMonitor_onSpeedChanged( MonitorMonitor _this, XObject sender );

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorMonitor_onECGGainChanged( MonitorMonitor _this, XObject sender );

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorMonitor_onABPGainChanged( MonitorMonitor _this, XObject sender );

/* 'C' function for method : 'Monitor::Monitor.updateCaption()' */
void MonitorMonitor_updateCaption( MonitorMonitor _this, XObject sender );

/* 'C' function for method : 'Monitor::Monitor.onOpenABPMinMax()' */
void MonitorMonitor_onOpenABPMinMax( MonitorMonitor _this, XObject sender );

/* 'C' function for method : 'Monitor::Monitor.openDialog()' */
void MonitorMonitor_openDialog( MonitorMonitor _this, MonitorDialog aDlg, XColor 
  aItemColor );

/* 'C' function for method : 'Monitor::Monitor.onOpenECGSettings()' */
void MonitorMonitor_onOpenECGSettings( MonitorMonitor _this, XObject sender );

/* 'C' function for method : 'Monitor::Monitor.onOpenABPSettings()' */
void MonitorMonitor_onOpenABPSettings( MonitorMonitor _this, XObject sender );

/* 'C' function for method : 'Monitor::Monitor.onOpenSpO2MinMax()' */
void MonitorMonitor_onOpenSpO2MinMax( MonitorMonitor _this, XObject sender );

/* 'C' function for method : 'Monitor::Monitor.onOpenEtCO2MinMax()' */
void MonitorMonitor_onOpenEtCO2MinMax( MonitorMonitor _this, XObject sender );

/* 'C' function for method : 'Monitor::Monitor.onOpenTempMinMax()' */
void MonitorMonitor_onOpenTempMinMax( MonitorMonitor _this, XObject sender );

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorMonitor_onECGIntensityChanged( MonitorMonitor _this, XObject sender );

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorMonitor_onABPIntensityChanged( MonitorMonitor _this, XObject sender );

/* Slot method to trigger the next phase of the auto demo. */
void MonitorMonitor_AutoDemoSlot( MonitorMonitor _this, XObject sender );

/* 'C' function for method : 'Monitor::Monitor.onOpenInfo()' */
void MonitorMonitor_onOpenInfo( MonitorMonitor _this, XObject sender );

#ifdef __cplusplus
  }
#endif

#endif /* _MonitorMonitor_H */

/* Embedded Wizard */
