/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Rotated_90
* Screen size : <1280,720>
*
*******************************************************************************/

#ifndef _MonitorOscilloscope_H
#define _MonitorOscilloscope_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_CoreGroup.h"
#include "_CorePropertyObserver.h"
#include "_GraphicsPath.h"
#include "_ViewsImage.h"
#include "_ViewsRectangle.h"
#include "_ViewsText.h"

/* Forward declaration of the class Core::DialogContext */
#ifndef _CoreDialogContext_
  EW_DECLARE_CLASS( CoreDialogContext )
#define _CoreDialogContext_
#endif

/* Forward declaration of the class Core::KeyPressHandler */
#ifndef _CoreKeyPressHandler_
  EW_DECLARE_CLASS( CoreKeyPressHandler )
#define _CoreKeyPressHandler_
#endif

/* Forward declaration of the class Core::LayoutContext */
#ifndef _CoreLayoutContext_
  EW_DECLARE_CLASS( CoreLayoutContext )
#define _CoreLayoutContext_
#endif

/* Forward declaration of the class Core::TaskQueue */
#ifndef _CoreTaskQueue_
  EW_DECLARE_CLASS( CoreTaskQueue )
#define _CoreTaskQueue_
#endif

/* Forward declaration of the class Core::View */
#ifndef _CoreView_
  EW_DECLARE_CLASS( CoreView )
#define _CoreView_
#endif

/* Forward declaration of the class Effects::Fader */
#ifndef _EffectsFader_
  EW_DECLARE_CLASS( EffectsFader )
#define _EffectsFader_
#endif

/* Forward declaration of the class Graphics::Canvas */
#ifndef _GraphicsCanvas_
  EW_DECLARE_CLASS( GraphicsCanvas )
#define _GraphicsCanvas_
#endif

/* Forward declaration of the class Monitor::DataStorage */
#ifndef _MonitorDataStorage_
  EW_DECLARE_CLASS( MonitorDataStorage )
#define _MonitorDataStorage_
#endif

/* Forward declaration of the class Monitor::Oscilloscope */
#ifndef _MonitorOscilloscope_
  EW_DECLARE_CLASS( MonitorOscilloscope )
#define _MonitorOscilloscope_
#endif


/* The oscilloscope class. An oscilloscope (abbreviated sometimes as scope or O-scope) 
   is a type of electronic test instrument that allows signal voltages to be viewed, 
   usually as a two-dimensional graph of one or more electrical potential differences 
   (vertical axis) plotted as a function of time or of some other voltage (horizontal 
   axis). Although an oscilloscope displays voltage on its vertical axis, any other 
   quantity that can be converted to a voltage can be displayed as well. In most 
   instances, oscilloscopes show events that repeat with either no change, or change 
   slowly. The oscilloscope is one of the most versatile and widely-used electronic 
   instruments. Within this demo application the oscilloscope displays the given 
   set of data by using a simulated electronic beam. */
EW_DEFINE_FIELDS( MonitorOscilloscope, CoreGroup )
  EW_OBJECT  ( Image,           ViewsImage )
  EW_OBJECT  ( Path,            GraphicsPath )
  EW_OBJECT  ( UpdateGraph,     CorePropertyObserver )
  EW_OBJECT  ( ScaleL,          ViewsRectangle )
  EW_OBJECT  ( ScaleT,          ViewsRectangle )
  EW_OBJECT  ( ScaleB,          ViewsRectangle )
  EW_OBJECT  ( Text,            ViewsText )
  EW_VARIABLE( Canvas,          GraphicsCanvas )
  EW_PROPERTY( DataProvider,    MonitorDataStorage )
  EW_PROPERTY( Caption,         XString )
  EW_PROPERTY( Speed,           XInt32 )
  EW_PROPERTY( WiperWidth,      XInt32 )
  EW_PROPERTY( Color,           XColor )
  EW_PROPERTY( Gain,            XInt32 )
  EW_VARIABLE( lastX,           XFloat )
  EW_VARIABLE( lastY,           XFloat )
  EW_PROPERTY( LineWidth,       XFloat )
  EW_VARIABLE( lastIndex,       XInt32 )
  EW_PROPERTY( BaseLine,        XInt32 )
EW_END_OF_FIELDS( MonitorOscilloscope )

/* Virtual Method Table (VMT) for the class : 'Monitor::Oscilloscope' */
EW_DEFINE_METHODS( MonitorOscilloscope, CoreGroup )
  EW_METHOD( initLayoutContext, void )( CoreRectView _this, XRect aBounds, CoreOutline 
    aOutline )
  EW_METHOD( GetRoot,           CoreRoot )( CoreView _this )
  EW_METHOD( Draw,              void )( CoreGroup _this, GraphicsCanvas aCanvas, 
    XRect aClip, XPoint aOffset, XInt32 aOpacity, XBool aBlend )
  EW_METHOD( GetClipping,       XRect )( CoreGroup _this )
  EW_METHOD( HandleEvent,       XObject )( CoreView _this, CoreEvent aEvent )
  EW_METHOD( CursorHitTest,     CoreCursorHit )( CoreGroup _this, XRect aArea, XInt32 
    aFinger, XInt32 aStrikeCount, CoreView aDedicatedView, CoreView aStartView, 
    XSet aRetargetReason )
  EW_METHOD( AdjustDrawingArea, XRect )( CoreGroup _this, XRect aArea )
  EW_METHOD( ArrangeView,       XPoint )( CoreRectView _this, XRect aBounds, XEnum 
    aFormation )
  EW_METHOD( MoveView,          void )( CoreRectView _this, XPoint aOffset, XBool 
    aFastMove )
  EW_METHOD( GetExtent,         XRect )( CoreRectView _this )
  EW_METHOD( ChangeViewState,   void )( CoreGroup _this, XSet aSetState, XSet aClearState )
  EW_METHOD( OnSetBounds,       void )( CoreGroup _this, XRect value )
  EW_METHOD( OnSetFocus,        void )( CoreGroup _this, CoreView value )
  EW_METHOD( OnSetBuffered,     void )( CoreGroup _this, XBool value )
  EW_METHOD( OnSetOpacity,      void )( CoreGroup _this, XInt32 value )
  EW_METHOD( DispatchEvent,     XObject )( CoreGroup _this, CoreEvent aEvent )
  EW_METHOD( BroadcastEvent,    XObject )( CoreGroup _this, CoreEvent aEvent, XSet 
    aFilter )
  EW_METHOD( UpdateLayout,      void )( MonitorOscilloscope _this, XPoint aSize )
  EW_METHOD( UpdateViewState,   void )( CoreGroup _this, XSet aState )
  EW_METHOD( InvalidateArea,    void )( CoreGroup _this, XRect aArea )
EW_END_OF_METHODS( MonitorOscilloscope )

/* The method UpdateLayout() is invoked automatically after the size of the component 
   has been changed. This method can be overridden and filled with logic to perform 
   a sophisticated arrangement calculation for one or more enclosed views. In this 
   case the parameter aSize can be used. It contains the current size of the component. 
   Usually, all enclosed views are arranged automatically accordingly to their @Layout 
   property. UpdateLayout() gives the derived components a chance to extend this 
   automatism by a user defined algorithm. */
void MonitorOscilloscope_UpdateLayout( MonitorOscilloscope _this, XPoint aSize );

/* The onset method for the property 'Speed' changes the speed of the beam in the 
   range from 1 to 1000. */
void MonitorOscilloscope_OnSetSpeed( MonitorOscilloscope _this, XInt32 value );

/* The onset method for the property 'ScreenWiper' changes the width of the screen 
   wiper in the range from 0 (off) to 100 percent. */
void MonitorOscilloscope_OnSetWiperWidth( MonitorOscilloscope _this, XInt32 value );

/* The onset method for the property 'BeamColor' changes the color of the simulated 
   beam. */
void MonitorOscilloscope_OnSetColor( MonitorOscilloscope _this, XColor value );

/* The onset method for the property 'Gain' changes the vertical scaling factor 
   in the range from 0 to 1000 percent. */
void MonitorOscilloscope_OnSetGain( MonitorOscilloscope _this, XInt32 value );

/* The onset method for the property 'DataProvider' updates the data provider with 
   the current settings. */
void MonitorOscilloscope_OnSetDataProvider( MonitorOscilloscope _this, MonitorDataStorage 
  value );

/* The onset method for the property 'ScreenWiper' changes the width of the screen 
   wiper in the range from 0 (off) to 100 percent. */
void MonitorOscilloscope_OnSetLineWidth( MonitorOscilloscope _this, XFloat value );

/* This slot method is executed when the associated property observer 'PropertyObserver' 
   is notified. */
void MonitorOscilloscope_onUpdate( MonitorOscilloscope _this, XObject sender );

/* 'C' function for method : 'Monitor::Oscilloscope.OnSetCaption()' */
void MonitorOscilloscope_OnSetCaption( MonitorOscilloscope _this, XString value );

#ifdef __cplusplus
  }
#endif

#endif /* _MonitorOscilloscope_H */

/* Embedded Wizard */
