/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Rotated_90
* Screen size : <1280,720>
*
*******************************************************************************/

#ifndef _MonitorValueItem_H
#define _MonitorValueItem_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_MonitorIconButton.h"
#include "_TemplatesValueDisplay.h"
#include "_ViewsRectangle.h"
#include "_ViewsText.h"

/* Forward declaration of the class Core::DialogContext */
#ifndef _CoreDialogContext_
  EW_DECLARE_CLASS( CoreDialogContext )
#define _CoreDialogContext_
#endif

/* Forward declaration of the class Core::Group */
#ifndef _CoreGroup_
  EW_DECLARE_CLASS( CoreGroup )
#define _CoreGroup_
#endif

/* Forward declaration of the class Core::KeyPressHandler */
#ifndef _CoreKeyPressHandler_
  EW_DECLARE_CLASS( CoreKeyPressHandler )
#define _CoreKeyPressHandler_
#endif

/* Forward declaration of the class Core::LayoutContext */
#ifndef _CoreLayoutContext_
  EW_DECLARE_CLASS( CoreLayoutContext )
#define _CoreLayoutContext_
#endif

/* Forward declaration of the class Core::TaskQueue */
#ifndef _CoreTaskQueue_
  EW_DECLARE_CLASS( CoreTaskQueue )
#define _CoreTaskQueue_
#endif

/* Forward declaration of the class Core::View */
#ifndef _CoreView_
  EW_DECLARE_CLASS( CoreView )
#define _CoreView_
#endif

/* Forward declaration of the class Effects::Fader */
#ifndef _EffectsFader_
  EW_DECLARE_CLASS( EffectsFader )
#define _EffectsFader_
#endif

/* Forward declaration of the class Graphics::Canvas */
#ifndef _GraphicsCanvas_
  EW_DECLARE_CLASS( GraphicsCanvas )
#define _GraphicsCanvas_
#endif

/* Forward declaration of the class Monitor::ValueItem */
#ifndef _MonitorValueItem_
  EW_DECLARE_CLASS( MonitorValueItem )
#define _MonitorValueItem_
#endif


/* This class implements an 'instrument', used to display e.g. measured values. 
   The widget is controlled by the properties @CurrentValue and @Unit.
   Alternatively the property @Outlet can refer to any other 'int32' property the 
   widget should remain synchronized with. When the referred property is modified 
   by another one, the widget is automatically notified to remain in sync with the 
   property.
   This approach follows the Model-View-Controller (MVC) programming paradigm. Here 
   the widget represents the 'View' and the property referred via 'Outlet' can be 
   seen as a part of the 'Model'. */
EW_DEFINE_FIELDS( MonitorValueItem, TemplatesValueDisplay )
  EW_OBJECT  ( Text,            ViewsText )
  EW_OBJECT  ( HeaderText,      ViewsText )
  EW_OBJECT  ( IconButton,      MonitorIconButton )
  EW_OBJECT  ( FooterText,      ViewsText )
  EW_OBJECT  ( HeaderLine,      ViewsRectangle )
  EW_OBJECT  ( FooterLine,      ViewsRectangle )
  EW_OBJECT  ( TextDigit,       ViewsText )
  EW_PROPERTY( OnActivate,      XSlot )
  EW_PROPERTY( CurrentOutlet,   XRef )
  EW_PROPERTY( MinOutlet,       XRef )
  EW_PROPERTY( MaxOutlet,       XRef )
  EW_PROPERTY( Caption,         XString )
  EW_PROPERTY( CurrentValue,    XInt32 )
  EW_PROPERTY( Color,           XColor )
  EW_PROPERTY( MinValue,        XInt32 )
  EW_PROPERTY( MaxValue,        XInt32 )
  EW_PROPERTY( ButtonColor,     XColor )
  EW_PROPERTY( DecimalPlace,    XBool )
EW_END_OF_FIELDS( MonitorValueItem )

/* Virtual Method Table (VMT) for the class : 'Monitor::ValueItem' */
EW_DEFINE_METHODS( MonitorValueItem, TemplatesValueDisplay )
  EW_METHOD( initLayoutContext, void )( CoreRectView _this, XRect aBounds, CoreOutline 
    aOutline )
  EW_METHOD( GetRoot,           CoreRoot )( CoreView _this )
  EW_METHOD( Draw,              void )( CoreGroup _this, GraphicsCanvas aCanvas, 
    XRect aClip, XPoint aOffset, XInt32 aOpacity, XBool aBlend )
  EW_METHOD( GetClipping,       XRect )( CoreGroup _this )
  EW_METHOD( HandleEvent,       XObject )( CoreView _this, CoreEvent aEvent )
  EW_METHOD( CursorHitTest,     CoreCursorHit )( CoreGroup _this, XRect aArea, XInt32 
    aFinger, XInt32 aStrikeCount, CoreView aDedicatedView, CoreView aStartView, 
    XSet aRetargetReason )
  EW_METHOD( AdjustDrawingArea, XRect )( CoreGroup _this, XRect aArea )
  EW_METHOD( ArrangeView,       XPoint )( CoreRectView _this, XRect aBounds, XEnum 
    aFormation )
  EW_METHOD( MoveView,          void )( CoreRectView _this, XPoint aOffset, XBool 
    aFastMove )
  EW_METHOD( GetExtent,         XRect )( CoreRectView _this )
  EW_METHOD( ChangeViewState,   void )( CoreGroup _this, XSet aSetState, XSet aClearState )
  EW_METHOD( OnSetBounds,       void )( CoreGroup _this, XRect value )
  EW_METHOD( OnSetFocus,        void )( CoreGroup _this, CoreView value )
  EW_METHOD( OnSetBuffered,     void )( CoreGroup _this, XBool value )
  EW_METHOD( OnSetOpacity,      void )( CoreGroup _this, XInt32 value )
  EW_METHOD( DispatchEvent,     XObject )( CoreGroup _this, CoreEvent aEvent )
  EW_METHOD( BroadcastEvent,    XObject )( CoreGroup _this, CoreEvent aEvent, XSet 
    aFilter )
  EW_METHOD( UpdateLayout,      void )( CoreGroup _this, XPoint aSize )
  EW_METHOD( UpdateViewState,   void )( MonitorValueItem _this, XSet aState )
  EW_METHOD( InvalidateArea,    void )( CoreGroup _this, XRect aArea )
EW_END_OF_METHODS( MonitorValueItem )

/* The method UpdateViewState() is invoked automatically after the state of the 
   component has been changed. This method can be overridden and filled with logic 
   to ensure the visual aspect of the component does reflect its current state. 
   For example, the 'enabled' state of the component can affect its colors (disabled 
   components may appear pale). In this case the logic of the method should modify 
   the respective color properties accordingly to the current 'enabled' state. 
   The current state of the component is passed as a set in the parameter aState. 
   It reflects the very basic component state like its visibility or the ability 
   to react to user inputs. Beside this common state, the method can also involve 
   any other variables used in the component as long as they reflect its current 
   state. For example, the toggle switch component can take in account its toggle 
   state 'on' or 'off' and change accordingly the location of the slider, etc.
   Usually, this method will be invoked automatically by the framework. Optionally 
   you can request its invocation by using the method @InvalidateViewState(). */
void MonitorValueItem_UpdateViewState( MonitorValueItem _this, XSet aState );

/* This slot method will receive a signal, if the value of the property assigned 
   to @Outlet has been changed by another widget or by the application logic. In 
   response to this notification, the value display component will update itself. */
void MonitorValueItem_onOutlet( MonitorValueItem _this, XObject sender );

/* 'C' function for method : 'Monitor::ValueItem.OnSetCurrentOutlet()' */
void MonitorValueItem_OnSetCurrentOutlet( MonitorValueItem _this, XRef value );

/* 'C' function for method : 'Monitor::ValueItem.OnSetCurrentValue()' */
void MonitorValueItem_OnSetCurrentValue( MonitorValueItem _this, XInt32 value );

/* 'C' function for method : 'Monitor::ValueItem.OnSetColor()' */
void MonitorValueItem_OnSetColor( MonitorValueItem _this, XColor value );

/* 'C' function for method : 'Monitor::ValueItem.OnSetMinOutlet()' */
void MonitorValueItem_OnSetMinOutlet( MonitorValueItem _this, XRef value );

/* 'C' function for method : 'Monitor::ValueItem.OnSetMinValue()' */
void MonitorValueItem_OnSetMinValue( MonitorValueItem _this, XInt32 value );

/* 'C' function for method : 'Monitor::ValueItem.OnSetMaxOutlet()' */
void MonitorValueItem_OnSetMaxOutlet( MonitorValueItem _this, XRef value );

/* 'C' function for method : 'Monitor::ValueItem.OnSetMaxValue()' */
void MonitorValueItem_OnSetMaxValue( MonitorValueItem _this, XInt32 value );

/* 'C' function for method : 'Monitor::ValueItem.OnSetCaption()' */
void MonitorValueItem_OnSetCaption( MonitorValueItem _this, XString value );

/* 'C' function for method : 'Monitor::ValueItem.OnSetButtonColor()' */
void MonitorValueItem_OnSetButtonColor( MonitorValueItem _this, XColor value );

/* 'C' function for method : 'Monitor::ValueItem.OnSetOnActivate()' */
void MonitorValueItem_OnSetOnActivate( MonitorValueItem _this, XSlot value );

/* 'C' function for method : 'Monitor::ValueItem.OnSetDecimalPlace()' */
void MonitorValueItem_OnSetDecimalPlace( MonitorValueItem _this, XBool value );

#ifdef __cplusplus
  }
#endif

#endif /* _MonitorValueItem_H */

/* Embedded Wizard */
