/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Rotated_90
* Screen size : <1280,720>
*
*******************************************************************************/

#ifndef _WidgetSetRotaryKnobConfig_H
#define _WidgetSetRotaryKnobConfig_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_WidgetSetWidgetConfig.h"

/* Forward declaration of the class Resources::Bitmap */
#ifndef _ResourcesBitmap_
  EW_DECLARE_CLASS( ResourcesBitmap )
#define _ResourcesBitmap_
#endif

/* Forward declaration of the class WidgetSet::RotaryKnobConfig */
#ifndef _WidgetSetRotaryKnobConfig_
  EW_DECLARE_CLASS( WidgetSetRotaryKnobConfig )
#define _WidgetSetRotaryKnobConfig_
#endif


/* This class implements the functionality permitting you to simply customize the 
   look and feel of a 'rotary knob' widget (WidgetSet::RotaryKnob). In the practice, 
   you will create an instance of this class, configure its properties with bitmaps, 
   colors and other relevant attributes according to your design expectations and 
   assign such prepared configuration object to the property 'Appearance' of every 
   affected rotary knob widget. Thereupon the widgets will use the configuration 
   information provided in the object.
   During its lifetime the rotary knob remains always in one of the four states: 
   'disabled', 'default', 'focused' and 'active'. The state 'disabled' is true for 
   every not available rotary knob widget (the property 'Enabled' of the widget 
   is 'false'). Such widgets will ignore all user inputs. The state 'default' determines 
   a rotary knob widget, which is ready to be touched by the user or ready to become 
   focused. As soon as the rotary knob widget becomes focused, it switches in the 
   state 'focused'. In this state the user can control the widget by pressing keys 
   on the keyboard. Finally, the state 'active' is true, if the user actually interacts 
   with the widget (the thumb is pressed). With the configuration object you can 
   specify the appearance of the rotary knob for every state individually. For this 
   purpose you should know from which views the rotary knob is composed of:
   - 'ScaleImage' is an image view (Views::Image) displayed centered in the background 
   within the widget area. In the configuration object you can individually specify 
   for every widget state the desired bitmap (@ScaleBitmapActive, @ScaleBitmapDefault, 
   @ScaleBitmapDisabled, @ScaleBitmapFocused), the frame number within the bitmap 
   (@ScaleFrameActive, @ScaleFrameDefault, @ScaleFrameDisabled, @ScaleFrameFocused) 
   and opacity or color to tint the bitmap (@ScaleTintActive, @ScaleTintDefault, 
   @ScaleTintDisabled, @ScaleTintFocused). The rotary knob widget can automatically 
   play animated bitmaps if the specified frame number is -1.
   - 'TrackLeftArc' is a vector graphic view (Views::FillPath) displaying a circle 
   segment arranged per default between the thumbs's leftmost position (clockwise) 
   and its actual position. From this results the effect of a track behind the thumb. 
   You can configure the track radius (@TrackLeftRadiusDefault, @TrackLeftRadiusDisabled, 
   @TrackLeftRadiusFocused, @TrackLeftRadiusActive), its thickness (@TrackLeftThicknessDefault, 
   @TrackLeftThicknessDisabled, @TrackLeftThicknessFocused, @TrackLeftThicknessActive), 
   color (@TrackLeftColorDefault, @TrackLeftColorDisabled, @TrackLeftColorFocused, 
   @TrackLeftColorActive) and the appearance of its caps (@TrackLeftRoundedStart 
   and @TrackLeftRoundedEnd). With the properties @TrackLeftMarginStart and @TrackLeftMarginEnd 
   the start/end position of the track can be adjusted. With the property @TrackLeftStatic 
   the track can be configured to not depend on the actual thumb position. The center 
   position of the track is controlled by the property @CenterOffset.
   - 'TrackLeftBorder' is a vector graphic view (Views::StrokePath) displaying an 
   outline of the above described 'TrackLeftArc' and lying in front of it. Its shape 
   and position correspond thus to the of the 'TrackLeftArc'. The thickness of the 
   border (@TrackLeftBorderWidthActive, @TrackLeftBorderWidthDefault, @TrackLeftBorderWidthDisabled, 
   @TrackLeftBorderWidthFocused) and its color (@TrackLeftBorderColorActive, @TrackLeftBorderColorDefault, 
   @TrackLeftBorderColorDisabled, @TrackLeftBorderColorFocused) can be specified.
   - 'TrackRightArc' is a vector graphic view (Views::FillPath) displaying a circle 
   segment arranged per default between the actual position of the thumb and its 
   rightmost position (clockwise). From this results the effect of a track behind 
   the thumb. You can configure the track radius (@TrackRightRadiusDefault, @TrackRightRadiusDisabled, 
   @TrackRightRadiusFocused, @TrackRightRadiusActive), its thickness (@TrackRightThicknessDefault, 
   @TrackRightThicknessDisabled, @TrackRightThicknessFocused, @TrackRightThicknessActive), 
   color (@TrackRightColorDefault, @TrackRightColorDisabled, @TrackRightColorFocused, 
   @TrackRightColorActive) and the appearance of its caps (@TrackRightRoundedStart 
   and @TrackRightRoundedEnd). With the properties @TrackRightMarginStart and @TrackRightMarginEnd 
   the start/end position of the track can be adjusted. With the property @TrackRightStatic 
   the track can be configured to not depend on the actual thumb position. The center 
   position of the track is controlled by the property @CenterOffset.
   - 'TrackRightBorder' is a vector graphic view (Views::StrokePath) displaying 
   an outline of the above described 'TrackRightArc' and lying in front of it. Its 
   shape and position correspond thus to the of the 'TrackRightArc'. The thickness 
   of the border (@TrackRightBorderWidthActive, @TrackRightBorderWidthDefault, @TrackRightBorderWidthDisabled, 
   @TrackRightBorderWidthFocused) and its color (@TrackRightBorderColorActive, @TrackRightBorderColorDefault, 
   @TrackRightBorderColorDisabled, @TrackRightBorderColorFocused) can be specified.
   - 'ThumbRectangle' is a rectangle view (Views::Rectangle) displayed centered 
   at the thumb position, which corresponds to the current value of the rotary knob 
   widget. The thumb moves along a circle segment with radius determined in the 
   properties @ThumbRadiusDefault, @ThumbRadiusDisabled, @ThumbRadiusFocused and 
   @ThumbRadiusActive. The thumb movement range (circle segment) is specified in 
   the properties @ThumbMinAngle and @ThumbMaxAngle. The position to rotate the 
   thumb around it is determined in the properties @CenterOffset. In the configuration 
   object you can individually specify for every widget state the size of the view 
   (@ThumbSizeActive, @ThumbSizeDefault, @ThumbSizeDisabled, @ThumbSizeFocused) 
   and an additional displacement (@ThumbOffsetActive, @ThumbOffsetDefault, @ThumbOffsetDisabled, 
   @ThumbOffsetFocused). Normally, the thumb area has rectangular shape with sharp 
   corners. If desired the corners can be rounded (@ThumbCornerRadiusActive, @ThumbCornerRadiusDefault, 
   @ThumbCornerRadiusDisabled, @ThumbCornerRadiusFocused). The thumb area can be 
   filled with a solid color (@ThumbColorActive, @ThumbColorDefault, @ThumbColorDisabled, 
   @ThumbColorFocused).
   - 'ThumbBorder' is a border view (Views::Border) surrounding the above described 
   'ThumbRectangle' and lying in front of it. Its size, position and corner radius 
   correspond thus to the of the 'ThumbRectangle'. The thickness of the border (@ThumbBorderWidthActive, 
   @ThumbBorderWidthDefault, @ThumbBorderWidthDisabled, @ThumbBorderWidthFocused) 
   and its color (@ThumbBorderColorActive, @ThumbBorderColorDefault, @ThumbBorderColorDisabled, 
   @ThumbBorderColorFocused) can be specified.
   - 'ThumbShadow' is a shadow view (Views::Shadow) lying always behind the above 
   described 'ThumbRectangle' view. Its size, position and corner radius correspond 
   thus to the of the 'ThumbRectangle'. However, an additional displacement for 
   the shadow can be specified (@ThumbShadowOffsetActive, @ThumbShadowOffsetDefault, 
   @ThumbShadowOffsetDisabled, @ThumbShadowOffsetFocused). The color of the shadow 
   (@ThumbShadowColorActive, @ThumbShadowColorDefault, @ThumbShadowColorDisabled, 
   @ThumbShadowColorFocused) as well as its blur radius (@ThumbShadowBlurRadiusActive, 
   @ThumbShadowBlurRadiusDefault, @ThumbShadowBlurRadiusDisabled, @ThumbShadowBlurRadiusFocused) 
   can be specified.
   - 'ThumbImage' is a warp image view (Views::WarpImage) displayed and rotated 
   around predetermined pivot position along a circle segment with given radius. 
   The desired thumb movement range (circle segment) is specified in the properties 
   @ThumbMinAngle and @ThumbMaxAngle. The radius of the circle segment is determined 
   by the properties @ThumbRadiusDefault, @ThumbRadiusDisabled, @ThumbRadiusFocused 
   and @ThumbRadiusActive. The position to rotate the thumb around it is determined 
   in the properties @CenterOffset and @ThumbPivot. With the property @ThumbRotate 
   you control whether the bitmap should appear rotated or only moved along the 
   circle segment. Furtermore, with the properties @ThumbOffsetDefault, @ThumbOffsetDisabled, 
   @ThumbOffsetFocused and @ThumbOffsetActive an additional displacement for the 
   resulting image (after rotation) is determined. In the configuration object you 
   can individually specify for every widget state the desired bitmap (@ThumbBitmapActive, 
   @ThumbBitmapDefault, @ThumbBitmapDisabled, @ThumbBitmapFocused), the frame number 
   within the bitmap (@ThumbFrameActive, @ThumbFrameDefault, @ThumbFrameDisabled, 
   @ThumbFrameFocused) and opacity or color to tint the bitmap (@ThumbTintActive, 
   @ThumbTintDefault, @ThumbTintDisabled, @ThumbTintFocused). The rotary knob widget 
   can automatically play animated bitmaps if the specified frame number is -1.
   - 'AccentRectangle' is a rectangle view (Views::Rectangle) displayed centered 
   at the thumb position, which corresponds to the current value of the rotary knob 
   widget. The thumb moves along a circle segment with radius determined in the 
   properties @ThumbRadiusDefault, @ThumbRadiusDisabled, @ThumbRadiusFocused and 
   @ThumbRadiusActive. The thumb movement range (circle segment) is specified in 
   the properties @ThumbMinAngle and @ThumbMaxAngle. The position to rotate the 
   thumb around it is determined in the properties @CenterOffset. In the configuration 
   object you can individually specify for every widget state the size of the view 
   (@AccentSizeActive, @AccentSizeDefault, @AccentSizeDisabled, @AccentSizeFocused) 
   and an additional displacement (@AccentOffsetActive, @AccentOffsetDefault, @AccentOffsetDisabled, 
   @AccentOffsetFocused). Normally, the accent area has rectangular shape with sharp 
   corners. If desired the corners can be rounded (@AccentCornerRadiusActive, @AccentCornerRadiusDefault, 
   @AccentCornerRadiusDisabled, @AccentCornerRadiusFocused). The accent area can 
   be filled with a solid color (@AccentColorActive, @AccentColorDefault, @AccentColorDisabled, 
   @AccentColorFocused). Accent usually serves to highlight the widget when the 
   user interacts with it actively or when the widget is focused.
   - 'AccentBorder' is a border view (Views::Border) surrounding the above described 
   'AccentRectangle' and lying in front of it. Its size, position and corner radius 
   correspond thus to the of the 'AccentRectangle'. The thickness of the border 
   (@AccentBorderWidthActive, @AccentBorderWidthDefault, @AccentBorderWidthDisabled, 
   @AccentBorderWidthFocused) and its color (@AccentBorderColorActive, @AccentBorderColorDefault, 
   @AccentBorderColorDisabled, @AccentBorderColorFocused) can be specified. Accent 
   usually serves to highlight the widget when the user interacts with it actively 
   or when the widget is focused.
   - 'CoverImage' is an image view (Views::Image) displayed centered within the 
   widget area and covering so eventually the scale and thumb images. In the configuration 
   object you can individually specify for every widget state the desired bitmap 
   (@CoverBitmapActive, @CoverBitmapDefault, @CoverBitmapDisabled, @CoverBitmapFocused), 
   the frame number within the bitmap (@CoverFrameActive, @CoverFrameDefault, @CoverFrameDisabled, 
   @CoverFrameFocused) and opacity or color to tint the bitmap (@CoverTintActive, 
   @CoverTintDefault, @CoverTintDisabled, @CoverTintFocused). The rotary knob widget 
   can automatically play animated bitmaps if the specified frame number is -1.
   All above mentioned views are arranged one above the other whereby the resulting 
   stacking order can be configured by using the properties @ScaleStackingPriority, 
   @TrackLeftStackingPriority, @TrackRightStackingPriority, @ThumbStackingPriority, 
   @AccentStackingPriority and @CoverStackingPriority. The view with higher priority 
   will appear in front of other views with lower priority.
   Normally, when a state alternation occurs, the affected views are updated immediatelly 
   to reflect the new state. By using the property @StateTransitionDuration it is 
   possible to configure the rotary knob widget to perform state alternations with 
   animations (e.g. the displacement of the thumb shadow can be animated). This 
   affects all attributes of the arc, rectangle, border and shadow views belonging 
   to the thumb, left track, right track and accent. In case of the images displayed 
   in the scale, thumb and cover, the animation has an effect only on the colors 
   and offsets used to configure the views. Consequently, during animations these 
   views can fade-out/in their colors and move only.
   If the rotary knob is actually focused, it can also be controlled by pressing 
   the keyboard keys specified in the properties @KeyCodeLeft and @KeyCodeRight 
   causing the thumb to be rotated counterclockwise or clockwise. To prevent the 
   rotary knob from being able to be focused, initialize these properties with the 
   value Core::KeyCode.NoKey. With the properties @KeyRepeatDelay and @KeyRepeatPeriod 
   you can configure whether the thumb should be moved autonomously when the user 
   holds the key pressed for a while.
   To further enhance the widgets, a slot method can be assigned to the property 
   @OnUpdate. Within the slot method new decoration views can be added to the widgets 
   and updated according to the current state of the widget. 
   With the properties @WidgetMinSize and @WidgetMaxSize you can configure size 
   constraints for the widget itself. You can, for example, limit the rotary knob 
   to not shrink below a specified width or height. */
EW_DEFINE_FIELDS( WidgetSetRotaryKnobConfig, WidgetSetWidgetConfig )
  EW_PROPERTY( ThumbBitmapActive, ResourcesBitmap )
  EW_PROPERTY( ThumbBitmapFocused, ResourcesBitmap )
  EW_PROPERTY( ThumbBitmapDefault, ResourcesBitmap )
  EW_PROPERTY( ScaleBitmapActive, ResourcesBitmap )
  EW_PROPERTY( ScaleBitmapFocused, ResourcesBitmap )
  EW_PROPERTY( ScaleBitmapDisabled, ResourcesBitmap )
  EW_PROPERTY( ScaleBitmapDefault, ResourcesBitmap )
  EW_PROPERTY( ThumbPivot,      XPoint )
  EW_PROPERTY( ThumbMaxAngle,   XFloat )
  EW_PROPERTY( ThumbMinAngle,   XFloat )
  EW_PROPERTY( WidgetMaxSize,   XPoint )
  EW_PROPERTY( WidgetMinSize,   XPoint )
EW_END_OF_FIELDS( WidgetSetRotaryKnobConfig )

/* Virtual Method Table (VMT) for the class : 'WidgetSet::RotaryKnobConfig' */
EW_DEFINE_METHODS( WidgetSetRotaryKnobConfig, WidgetSetWidgetConfig )
EW_END_OF_METHODS( WidgetSetRotaryKnobConfig )

/* 'C' function for method : 'WidgetSet::RotaryKnobConfig.OnSetThumbPivot()' */
void WidgetSetRotaryKnobConfig_OnSetThumbPivot( WidgetSetRotaryKnobConfig _this, 
  XPoint value );

/* 'C' function for method : 'WidgetSet::RotaryKnobConfig.OnSetThumbBitmapActive()' */
void WidgetSetRotaryKnobConfig_OnSetThumbBitmapActive( WidgetSetRotaryKnobConfig _this, 
  ResourcesBitmap value );

/* 'C' function for method : 'WidgetSet::RotaryKnobConfig.OnSetThumbBitmapFocused()' */
void WidgetSetRotaryKnobConfig_OnSetThumbBitmapFocused( WidgetSetRotaryKnobConfig _this, 
  ResourcesBitmap value );

/* 'C' function for method : 'WidgetSet::RotaryKnobConfig.OnSetThumbBitmapDefault()' */
void WidgetSetRotaryKnobConfig_OnSetThumbBitmapDefault( WidgetSetRotaryKnobConfig _this, 
  ResourcesBitmap value );

/* 'C' function for method : 'WidgetSet::RotaryKnobConfig.OnSetThumbMaxAngle()' */
void WidgetSetRotaryKnobConfig_OnSetThumbMaxAngle( WidgetSetRotaryKnobConfig _this, 
  XFloat value );

/* 'C' function for method : 'WidgetSet::RotaryKnobConfig.OnSetThumbMinAngle()' */
void WidgetSetRotaryKnobConfig_OnSetThumbMinAngle( WidgetSetRotaryKnobConfig _this, 
  XFloat value );

/* 'C' function for method : 'WidgetSet::RotaryKnobConfig.OnSetScaleBitmapActive()' */
void WidgetSetRotaryKnobConfig_OnSetScaleBitmapActive( WidgetSetRotaryKnobConfig _this, 
  ResourcesBitmap value );

/* 'C' function for method : 'WidgetSet::RotaryKnobConfig.OnSetScaleBitmapFocused()' */
void WidgetSetRotaryKnobConfig_OnSetScaleBitmapFocused( WidgetSetRotaryKnobConfig _this, 
  ResourcesBitmap value );

/* 'C' function for method : 'WidgetSet::RotaryKnobConfig.OnSetScaleBitmapDisabled()' */
void WidgetSetRotaryKnobConfig_OnSetScaleBitmapDisabled( WidgetSetRotaryKnobConfig _this, 
  ResourcesBitmap value );

/* 'C' function for method : 'WidgetSet::RotaryKnobConfig.OnSetScaleBitmapDefault()' */
void WidgetSetRotaryKnobConfig_OnSetScaleBitmapDefault( WidgetSetRotaryKnobConfig _this, 
  ResourcesBitmap value );

/* 'C' function for method : 'WidgetSet::RotaryKnobConfig.OnSetWidgetMaxSize()' */
void WidgetSetRotaryKnobConfig_OnSetWidgetMaxSize( WidgetSetRotaryKnobConfig _this, 
  XPoint value );

/* 'C' function for method : 'WidgetSet::RotaryKnobConfig.OnSetWidgetMinSize()' */
void WidgetSetRotaryKnobConfig_OnSetWidgetMinSize( WidgetSetRotaryKnobConfig _this, 
  XPoint value );

#ifdef __cplusplus
  }
#endif

#endif /* _WidgetSetRotaryKnobConfig_H */

/* Embedded Wizard */
